diff --git a/scripts/gendwarfksyms/gendwarfksyms.c b/scripts/gendwarfksyms/gendwarfksyms.c
index d209b237766b..e2f8ee5a4bf3 100644
--- a/scripts/gendwarfksyms/gendwarfksyms.c
+++ b/scripts/gendwarfksyms/gendwarfksyms.c
@@ -118,6 +118,8 @@ int main(int argc, const char **argv)
 			return -1;
 		}
 
+		check(symbol_read_symtab(fd));
+
 		dwfl = dwfl_begin(&callbacks);
 		if (!dwfl) {
 			error("dwfl_begin failed for '%s': %s", object_files[n],
diff --git a/scripts/gendwarfksyms/gendwarfksyms.h b/scripts/gendwarfksyms/gendwarfksyms.h
index 03f3e408a839..cb9106dfddb9 100644
--- a/scripts/gendwarfksyms/gendwarfksyms.h
+++ b/scripts/gendwarfksyms/gendwarfksyms.h
@@ -61,6 +61,10 @@ extern bool debug;
 /*
  * symbols.c
  */
+struct symbol_addr {
+	uint32_t section;
+	Elf64_Addr address;
+};
 
 static inline u32 name_hash(const char *name)
 {
@@ -69,10 +73,13 @@ static inline u32 name_hash(const char *name)
 
 struct symbol {
 	const char *name;
+	struct symbol_addr addr;
+	struct hlist_node addr_hash;
 	struct hlist_node name_hash;
 };
 
 extern int symbol_read_exports(FILE *file);
+extern int symbol_read_symtab(int fd);
 extern struct symbol *symbol_get(const char *name);
 
 /*
diff --git a/scripts/gendwarfksyms/symbols.c b/scripts/gendwarfksyms/symbols.c
index 673ad9cf9e77..f96acb941196 100644
--- a/scripts/gendwarfksyms/symbols.c
+++ b/scripts/gendwarfksyms/symbols.c
@@ -6,11 +6,43 @@
 #include "gendwarfksyms.h"
 
 #define SYMBOL_HASH_BITS 15
+
+/* struct symbol_addr -> struct symbol */
+static DEFINE_HASHTABLE(symbol_addrs, SYMBOL_HASH_BITS);
+/* name -> struct symbol */
 static DEFINE_HASHTABLE(symbol_names, SYMBOL_HASH_BITS);
 
+static inline u32 symbol_addr_hash(const struct symbol_addr *addr)
+{
+	return jhash(addr, sizeof(struct symbol_addr), 0);
+}
+
 typedef int (*symbol_callback_t)(struct symbol *, void *arg);
 
-static int for_each(const char *name, symbol_callback_t func, void *data)
+static int __for_each_addr(struct symbol *sym, symbol_callback_t func,
+			   void *data)
+{
+	struct hlist_node *tmp;
+	struct symbol *match = NULL;
+	int processed = 0;
+
+	hash_for_each_possible_safe(symbol_addrs, match, tmp, addr_hash,
+				    symbol_addr_hash(&sym->addr)) {
+		if (match == sym)
+			continue; /* Already processed */
+
+		if (match->addr.section == sym->addr.section &&
+		    match->addr.address == sym->addr.address) {
+			check(func(match, data));
+			++processed;
+		}
+	}
+
+	return processed;
+}
+
+static int for_each(const char *name, bool name_only, symbol_callback_t func,
+		    void *data)
 {
 	struct hlist_node *tmp;
 	struct symbol *match;
@@ -23,9 +55,13 @@ static int for_each(const char *name, symbol_callback_t func, void *data)
 		if (strcmp(match->name, name))
 			continue;
 
+		/* Call func for the match, and all address matches */
 		if (func)
 			check(func(match, data));
 
+		if (!name_only && match->addr.section != SHN_UNDEF)
+			return checkp(__for_each_addr(match, func, data)) + 1;
+
 		return 1;
 	}
 
@@ -34,7 +70,7 @@ static int for_each(const char *name, symbol_callback_t func, void *data)
 
 static bool is_exported(const char *name)
 {
-	return checkp(for_each(name, NULL, NULL)) > 0;
+	return checkp(for_each(name, true, NULL, NULL)) > 0;
 }
 
 int symbol_read_exports(FILE *file)
@@ -57,13 +93,14 @@ int symbol_read_exports(FILE *file)
 		if (is_exported(name))
 			continue; /* Ignore duplicates */
 
-		sym = malloc(sizeof(struct symbol));
+		sym = calloc(1, sizeof(struct symbol));
 		if (!sym) {
-			error("malloc failed");
+			error("calloc failed");
 			return -1;
 		}
 
 		sym->name = name;
+		sym->addr.section = SHN_UNDEF;
 		name = NULL;
 
 		hash_add(symbol_names, &sym->name_hash, name_hash(sym->name));
@@ -91,6 +128,120 @@ struct symbol *symbol_get(const char *name)
 {
 	struct symbol *sym = NULL;
 
-	for_each(name, get_symbol, &sym);
+	for_each(name, false, get_symbol, &sym);
 	return sym;
 }
+
+typedef int (*elf_symbol_callback_t)(const char *name, GElf_Sym *sym,
+				     Elf32_Word xndx, void *arg);
+
+static int elf_for_each_symbol(int fd, elf_symbol_callback_t func, void *arg)
+{
+	size_t sym_size;
+	GElf_Shdr shdr_mem;
+	GElf_Shdr *shdr;
+	Elf_Data *xndx_data = NULL;
+	Elf_Scn *scn;
+	Elf *elf;
+
+	if (elf_version(EV_CURRENT) != EV_CURRENT) {
+		error("elf_version failed: %s", elf_errmsg(-1));
+		return -1;
+	}
+
+	elf = elf_begin(fd, ELF_C_READ_MMAP, NULL);
+	if (!elf) {
+		error("elf_begin failed: %s", elf_errmsg(-1));
+		return -1;
+	}
+
+	sym_size = gelf_getclass(elf) == ELFCLASS32 ? sizeof(Elf32_Sym) :
+						      sizeof(Elf64_Sym);
+
+	scn = elf_nextscn(elf, NULL);
+
+	while (scn) {
+		shdr = gelf_getshdr(scn, &shdr_mem);
+
+		if (shdr && shdr->sh_type == SHT_SYMTAB_SHNDX) {
+			xndx_data = elf_getdata(scn, NULL);
+			break;
+		}
+
+		scn = elf_nextscn(elf, scn);
+	}
+
+	scn = elf_nextscn(elf, NULL);
+
+	while (scn) {
+		shdr = gelf_getshdr(scn, &shdr_mem);
+
+		if (shdr && shdr->sh_type == SHT_SYMTAB) {
+			Elf_Data *data = elf_getdata(scn, NULL);
+			unsigned int nsyms = data->d_size / sym_size;
+			unsigned int n;
+
+			for (n = 0; n < nsyms; ++n) {
+				const char *name = NULL;
+				Elf32_Word xndx = 0;
+				GElf_Sym sym_mem;
+				GElf_Sym *sym;
+
+				sym = gelf_getsymshndx(data, xndx_data, n,
+						       &sym_mem, &xndx);
+
+				if (sym->st_shndx != SHN_XINDEX)
+					xndx = sym->st_shndx;
+
+				name = elf_strptr(elf, shdr->sh_link,
+						  sym->st_name);
+
+				/* Skip empty symbol names */
+				if (name && *name &&
+				    checkp(func(name, sym, xndx, arg)) > 0)
+					break;
+			}
+		}
+
+		scn = elf_nextscn(elf, scn);
+	}
+
+	return check(elf_end(elf));
+}
+
+static int set_symbol_addr(struct symbol *sym, void *arg)
+{
+	struct symbol_addr *addr = arg;
+
+	if (sym->addr.section == SHN_UNDEF) {
+		sym->addr.section = addr->section;
+		sym->addr.address = addr->address;
+		hash_add(symbol_addrs, &sym->addr_hash,
+			 symbol_addr_hash(&sym->addr));
+
+		debug("%s -> { %u, %lx }", sym->name, sym->addr.section,
+		      sym->addr.address);
+	} else {
+		warn("multiple addresses for symbol %s?", sym->name);
+	}
+
+	return 0;
+}
+
+static int process_symbol(const char *name, GElf_Sym *sym, Elf32_Word xndx,
+			  void *arg)
+{
+	struct symbol_addr addr = { .section = xndx, .address = sym->st_value };
+
+	/* Set addresses for exported symbols */
+	if (GELF_ST_BIND(sym->st_info) != STB_LOCAL &&
+	    addr.section != SHN_UNDEF)
+		checkp(for_each(name, true, set_symbol_addr, &addr));
+
+	return 0;
+}
+
+int symbol_read_symtab(int fd)
+{
+	return elf_for_each_symbol(fd, process_symbol, NULL);
+}